{% extends 'base.html' %}

{% load crispy_forms_tags %}
{% load custom_tags %}
{% load humanize %}

{% block content %}
    <h2>Search</h2><hr/>
    <p><strong>Instructions:</strong>
        Construct your search applying filters as required to narrow your results. If preview results look 
        appropriate, you may queue the search for download. Downloading is queued for nights and weekends. 
        Please plan ahead to ensure sufficient time to retrieve results. For more information on how to construct 
        more effective searches see <a href="#"  data-toggle="modal" data-target="#tipModal">these tips</a>. 
        To see a sample of the various download formats, <a href="samples.zip">click here to download</a>.
    </p>
    <form method="post" novalidate>
        {% is_over_max_searches num_current_user_searches as over_max_searches %}
        <input type='hidden' display="none" id='id_form-TOTAL_FORMS' value="1"/>
        <input type='hidden' displayed='none' id='is_admin' value='{% if  request.session.is_admin %}Y{% else %}N{% endif %}'/>
        <input type='hidden' displayed='none' id='is_at_limit' value='{% if over_max_searches and not request.session.is_admin %}Y{% else %}N{% endif %}'/>
        {% csrf_token %}
        <div class="row form-row spacer">
            <div class="col-4">
                <label for="id_search">{{form.search.label}}</label>
            </div>
            <div class="col-6">
                <div class="input-group">
                    {{form.search}}
                </div>
            </div>
        </div>
        <div class="row form-row spacer">
            <div class="col-4">
                <label for="id_filter_opts">{{form.filter_opts.label}}</label>
            </div>
            <div class="col-6">
                <div class="input-group">
                    {{form.filter_opts}}
                </div>
            </div>
        </div>
        <div class="search_filters">
        </div>
        <div class="row spacer">
            <div class="col-6 offset-4">
                <button type="submit" name='preview-search' class="btn btn-block btn-primary">Preview Search</button>
            </div>
        </div>
        <input type="hidden" id="post_data" value="{{ post_data }}" />
        <input type="hidden" id="result_data" name='result_data' value="{{ search_results_json }}" />

    {% for field in form %}
        {% if field.errors %}
            {% for error in field.errors %}
                <p class='error'> Error! {{ field.label }}: {{ error }} </p>
            {% endfor %}
        {% endif %}
    {% endfor %}

    {% if error_message %}
    <br/><p class='error'>{{ error_message }}</p>
    {% endif %}
    <hr/>

    <!-- SEARCH RESULTS -->
    {% if search_results %}
        {% if search_results.value|length == 0 %}
            <br/>
            <span class='result-count'>Your search returned <strong>0</strong> results. Please review your filter 
            criteria and try again.</span>
        {% else %}
            <h2>Queue Search For Full Download</h2>
            <p>
            Be sure to review the preview of the results below to ensure that you are happy with the filters before 
            queueing the full seach. The number of days to complete the download is estimated based on the number of 
            other searches in the queue and the number of allowed downloads per day by LexisNexis. The max amount of 
            results allowed for regular users is <strong>{% max_results_allowed %}</strong>.  
            Additionally, regular users can only have <strong>{% max_concurrent_searches %}</strong> running at once 
            (you are currently have {{ num_current_user_searches }}). Additional searches will be placed on hold until ready to run. 
            See the <a href="/about">About page</a> for who to contact for an exception to either of these limits. 
            Please note that for efficiency, results will be grouped sub-directories with a max of 
            <strong>{{ max_files_per_dir|intcomma }}</strong> files each.
            </p>
            <div class='queue-search'>
                    <div class='input-group radio'>
                        {% is_over_max search_results.count as over_max %}
                        <label><input type='radio' name='use_filter' id='use_existing' value='existing' 

                        data-toggle="collapse" data-target='#post_filters.show'
                        {% if over_max and not request.session.is_admin %} disabled {% endif %}
                        />Use existing filters ({{ search_results.count | intcomma }} results, approximately {{ search_results.est_days_to_complete | intcomma }} days to download)</label>
                    </div>
                    {% if search_results.postFilters|length > 0 %}
                        <div class='input-group radio'>
                            <label><input type='radio' checked name='use_filter' id='use_suggested' data-toggle="collapse" data-target='#post_filters:not(.show)' value='suggested'/>Select additional filter(s)&nbsp;<a href='' role='button' onClick='return false;' data-trigger='focus' data-html='true' data-toggle='popover' title='Additional Filters' data-content='These are suggestions provided by LexisNexis to help narrow down your search further. They are grouped by the field they filter on and show how many results you could expect by adding that filter. You can select one or more of these and either submit your search directly or refresh the preview of the results with the new filters. <strong>Note that the filter values populated may appear in code instead of plain text.</strong><br/><br/>'>(?)</a></label>
                        </div>
                        <div id='post_filters' class='form-row col-6'>
                            <select name='post_filters' class='sp' multiple data-live-search='true' data-width='100%' aria-label='post filters'>
                           {% for filterName, filterValues in search_results.postFilters.items %}
                                <optgroup label='{{ filterName }}'>
                                    {% for valueName, value in filterValues.items %}
                                        {% is_over_max value.Count as over_max %}
                                        <option value='{{ filterName }}||{{ value.Value }}||{{ value.Count }}'
                                            {% if over_max %}disabled{% endif %}>
                                {{ valueName }}({{ value.Count | intcomma }} results, {{ value.est_days_to_complete | intcomma }} day(s) to download)</span></option>
                                    {% endfor %}
                                </optgroup>
                            {% endfor %} 
                            </select>
                            <button type="submit" name='add-filters' class="btn btn-block btn-primary col-5 lmargin-10">Refresh Result Preview</button>
                        </div>
                    {% endif %}
                    <div id='advanced_options' class='pt-3'>
                        Would you like the results aggregated into a single file?
                        <input class='aggregate' type='radio' name='aggregate' value='yes' onclick='resetoptions(this,"yesopts","noopts","selected-format")'>Yes</input>
                        <input class='aggregate' type='radio' name='aggregate' value='no' checked onclick='resetoptions(this,"noopts","yesopts","selected-format")'>No</input>
                        <br/>Format of the results:</span>
                        <div id='yesopts' class='d-none'>
                            {% for format in available_formats %}
                                {% if format.aggregate %}
                                    <div class='input-group checkbox'>
                                        <label>
                                            <input type='radio' name='selected-format' class='selected-format' 
                                                   value='{{ format.id }}'
                                                   {% if format.name == "JSON" %} checked {% endif %}
                                            />
                                        {{ format.name }}&nbsp;
                                        <a href='#' role='button' onClick='return false;' data-trigger='focus' 
                                           data-html='true' data-toggle='popover' title='{{ format.name }}' data-content='{{ format.help_text }}'>(?)
                                        </a>
                                        </label>
                                    </div>
                                {% endif %}
                            {% endfor %}
                        </div>
                        <div id='noopts'>
                            {% for format in available_formats %}
                                {% if format.individual %}
                                    <div class='input-group checkbox'>
                                        <label>
                                            <input type='radio' name='selected-format' class='selected-format' 
                                                   value='{{ format.id }}'
                                                   {% if format.name == "JSON" %} checked {% endif %}
                                            />
                                        {{ format.name }}&nbsp;
                                        <a href='#' role='button' onClick='return false;' data-trigger='focus' 
                                           data-html='true' data-toggle='popover' title='{{ format.name }}' data-content='{{ format.help_text }}'>(?)
                                        </a>
                                        </label>
                                    </div>
                                {% endif %}
                            {% endfor %}
                        </div>
                    </div>
                    <div id='sort_order'>
                        Select the sort order for the results:
                        {% for sort_order in available_sort_orders %}
                            <div class='input-group radio'>
                            <label><input type='radio' name='selected-sort-order' value='{{ sort_order.sort_id }}' {% if forloop.first %} checked {% endif %}/> 
                                {{ sort_order.sort_label }}</label>
                            </div>
                        {% endfor %}
                    </div>  
                    <div>
                        (Optional) Additional user(s) you would like to have access to this search (entered as netids separated by space or comma):
			<div>
                        	<input type='text' name='addit_users' id='addit_users' class='form-control w-25' />
			</div>
                    </div>  
                    {% if request.session.is_admin %}
                        <div id='user_for' class='input-group'>
                            <label for="user_for" id='user_for_lbl' class='indent_right'>For User ID:&nbsp;
                                <a href='#' role='button' onClick='return false;' data-trigger='focus' data-html='true' 
                                    data-toggle='popover' title='For User ID' 
                                    data-content='Allows administrative users to queue searches for other users.<br/>Defaults to the current user.'>(?)</a>
                            </label>
                            <input type='text' name='user_for' id='user_for' class='form-control' placeholder='User ID' value='{{ request.session.userid }}'/>
                            </label>
                        </div>
                        <div class='input-group checkbox pt-3'>
                            <label>
                                <input type='checkbox' name='extract_only' class='selected-format' value='true'/>
                            Download Extract Only&nbsp;
                            <a href='#' role='button' onClick='return false;' data-trigger='focus' 
                               data-html='true' data-toggle='popover' 
                               title='Download Extract Only' 
                               data-content='Download only the extract of searches instead of the full text'>(?)
                            </a>
                            </label>
                        </div>
                    {% endif %}
                    <button type="submit" name='submit-search' id='submit-search' class="btn btn-block btn-primary col-6 offset-4">
                        Submit Search</button>
                    <p id='mult_filter_info'></p>
                </form>
            </div>
            <hr/>

            <h2 id='searchResultLbl'>Search Results Sample</h2>
            <span class='result-count'><strong>{{ search_results.count | intcomma }}</strong> result(s) found. Showing only the first <strong>{{ search_results.value | length }}</strong> result(s).</span><br/><br/>
            {% for result in search_results.value %}
                <div class='result'>
                    <span class='field-title'>Title: </span><span class='title'>{{ result.Title }}</span><br/>
                    <span class='field-title'>Date: </span><span class='date'>{{ result.Date|parse_iso|date:"F jS Y" }}</span>
                    <span class='pl-4 field-title overview-title'>Overview: </span><span class='overview'>{{ result.Overview }}</span><br/>
                    {% if result.Document %}
                        <span class='field-title'>Full Text: <button type="button" class="btn btn-info btn-sm" data-toggle="collapse" data-target="#extract-{{forloop.parentloop.counter}}">Show / Hide</button></span><br/>
                        <div class='extract collapse' id='extract-{{forloop.parentloop.counter}}'>{{ result.Document.Content | safe }}</div><br/>
                    {% else %}
                        <span class='field-title'>Extracts:</span>
                        <button type="button" class="btn btn-info btn-sm ml-2" data-toggle="collapse" data-target="#extract-{{forloop.counter}}">
                            Show / Hide
                        </button>
                        <div class='extract collapse' id='extract-{{forloop.counter}}'>
                        {% for extract in result.Extracts %}
                            {{ extract.SummaryText | safe }}<br/>
                        {% endfor %}
                        </div>
                    {% endif %}
                </div>
                </br>
            {% endfor %}

       {% endif %} 
    {% endif %}

    <!-- Modal -->
    <div class="modal fade" id="tipModal" tabindex="-1" role="dialog" aria-labelledby="tipModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h2 class="modal-title" id="tipModalLabel">Search Tips</h2>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <h2>Why Build Better Searches?</h2>
            <p>As downloading is queued for nights and weekends; more effective searches can reduce the time
            for results to be returned to researchers.
            <br/><br/>
            
            To see advanced query refinement syntax, review the
            <a href="https://www.lexisnexis.com/pdf/lexis-advance/terms-and-connectors.pdf">LexisNexis documentation</a>.
            </p>

            <h2>Selecting Filters</h2>
            <p>If no filters are provided, Text Assembler will search across all news sources in all languages for 
            all time periods. This can provide a very large number of results which will take a significant amount 
            of time to search.
            <br/><br/>
            In many cases, it will make sense to apply filters for only English language news or a date filter for 
            within the past month or year. Each one of the available filter options provides a help link ("?") to 
            give more insite as to what it will filter.
            <br/><br/>

            For the Source filter, you can start typing "AGG" into the filter box to see the list of aggregate sources
            which comprise of multiple individual sources and filters such as "(AGG) English Language News (Most
            Recent 90 Days)".
            </p>

          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-primary" data-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>
{% endblock %}
